<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xml:space="default">
	<xsl:output method="html" encoding="UTF-8" doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="http://www.w3.org/TR/html4/strict.dtd" />
	<xsl:strip-space elements="*"/>

	<xsl:template match="/">
		<table border="1">
			<tr>
				<th>core</th>
				<th>cpu</th>
				<th>speed</th>
				<th>signature</th>
				<th>rom</th>
				<th>int. ram</th>
				<th>ext. ram</th>
				<th>eeprom</th>
				<th colspan="8">fuses low (0..7)</th>
				<th colspan="8">fuses high (0..7)</th>
				<th colspan="8">fuses extended (0..7)</th>
				<th>power (active/idle/power down)</th>
			</tr>
		<xsl:for-each select="/atmel/AVRPART">
			<xsl:sort select="CORE/CORE_VERSION" order="ascending" data-type="text"/>
			<xsl:sort select="ADMIN/PART_NAME" order="ascending" data-type="text"/>
			<tr>
				<td><xsl:value-of select="CORE/CORE_VERSION"/></td>
				<td><xsl:value-of select="ADMIN/PART_NAME"/></td>
				<td><xsl:value-of select="ADMIN/SPEED"/></td>
				<td><xsl:value-of select="ADMIN/SIGNATURE"/></td>
				<td><xsl:value-of select="MEMORY/PROG_FLASH"/></td>
				<td><xsl:value-of select="MEMORY/INT_SRAM/SIZE"/></td>
				<td><xsl:value-of select="MEMORY/EXT_SRAM/SIZE"/></td>
				<td><xsl:value-of select="MEMORY/EEPROM"/></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE0/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE0/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE1/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE1/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE2/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE2/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE3/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE3/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE4/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE4/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE5/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE5/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE6/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE6/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/LOW/FUSE7/NAME"/><br/><small><i><xsl:value-of select="FUSE/LOW/FUSE7/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE0/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE0/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE1/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE1/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE2/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE2/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE3/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE3/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE4/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE4/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE5/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE5/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE6/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE6/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/HIGH/FUSE7/NAME"/><br/><small><i><xsl:value-of select="FUSE/HIGH/FUSE7/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE0/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE0/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE1/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE1/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE2/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE2/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE3/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE3/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE4/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE4/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE5/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE5/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE6/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE6/TEXT"/></i></small></td>
				<td><xsl:value-of select="FUSE/EXTENDED/FUSE7/NAME"/><br/><small><i><xsl:value-of select="FUSE/EXTENDED/FUSE7/TEXT"/></i></small></td>
				<td>
					<xsl:value-of select="POWER/CLOCK"/>/<xsl:value-of select="POWER/TEMP"/>:
					<xsl:value-of select="POWER/ACTIVE"/>/
					<xsl:value-of select="POWER/IDLE"/>/
					<xsl:value-of select="POWER/POWER_DOWN"/>
				</td>
			</tr>
		</xsl:for-each>
		</table>
	</xsl:template>
<!--
	<cpu name="ATmega8" maxspeed="16000000" voltage="5" mcusr="MCUCSR" wdtcsr="WDTCR" spi="true" reset="rjmp"></cpu>
-->
</xsl:stylesheet>
