; --------------
; --- eeprom ---
; --------------
<?if (B("03_eeprom:tx")) show(); else hide();?>
EEPROM_write:
	; Wait for completion of previous write
	sbic EECR,<?$cpu:eeprom:writeenable?>
	rjmp EEPROM_write
	; Set up address (r18:r17) in address register
	out EEARH, r18
	out EEARL, r17
	; Write data (r16) to Data Register
	out EEDR,r16
	; Write logical one to <?$cpu:eeprom:masterwriteenable?>
	sbi EECR,<?$cpu:eeprom:masterwriteenable?>
	; Start eeprom write by setting <?$cpu:eeprom:writeenable?>
	sbi EECR,<?$cpu:eeprom:writeenable?>
	ret
<?if (B("03_eeprom:rx")) show(); else hide();?>
EEPROM_read:
	; Wait for completion of previous write
	sbic EECR,<?$cpu:eeprom:writeenable?>
	rjmp EEPROM_read
	; Set up address (r18:r17) in address register
	out EEARH, r18
	out EEARL, r17
	; Start eeprom read by writing EERE
	sbi EECR,EERE
	; Read data from Data Register
	in r16,EEDR
	ret
<?show();P("\r\n\r\n; generated by AvrWiz on "+System.DateTime.Now);?>