#include "main.h"

#define sleep()<?if (N("cpu:sleep:index") > 0) P(" asm volatile (\"sleep\")");?>
<?if (B("00_main:interrupts")) show(); else hide();?>
// ------------------
// --- interrupts ---
// ------------------
<?XmlNodeList irqs = CPU.SelectNodes("irqs/irq");
foreach (XmlNode irq in irqs)
{
	bool ok = true;
	string name = irq.Attributes["name"].InnerText;
	if (B("00_main:enable usart") == true && B("02_usart:interrupts") == true)
	{
		if	 (S("02_usart:usart0:irq_rx") == name) ok = false;
		else if (S("02_usart:usart0:irq_tx") == name) ok = false;
		else if (S("02_usart:usart0:irq_de") == name) ok = false;
	}
	if (B("00_main:enable timer") == true && B("01_timer:interrupts") == true)
	{
		if	 (S("01_timer:timer0:irq_ovf") == name) ok = false;
		else if (S("01_timer:timer0:irq_capt") == name) ok = false;
		else if (S("01_timer:timer0:irq_compa") == name) ok = false;
		else if (S("01_timer:timer0:irq_compb") == name) ok = false;
		else if (S("01_timer:timer0:irq_compc") == name) ok = false;
	}
	if (ok == true)
	{
		P("\r\n// "+irq.Attributes["desc"].InnerText+"\r\n");
		P("ISR("+name+"_vect)\r\n");
		P("{\r\n");
		P("\t// <todo: insert your interrupt code here ...>\r\n");
		P("}\r\n");
	}
}
if (B("00_main:check reset type")) show(); else hide();?>
// ---------------------------
// --- check type of reset ---
// ---------------------------

void onWatchdogReset()
{
	// <todo: insert your watchdog-reset code here ...>
}

void onPowerOnReset()
{
	// <todo: insert your poweron-reset code here ...>
}

void onExternalReset()
{
	// <todo: insert your code external-reset code here ...>
}

void onBrownOutReset()
{
	// <todo: insert your brownout-reset code here ...>
}
<?if (B("00_main:check reset type") && B("cpu:jtag")) show(); else hide();?>
void onJTAGReset()
{
	// <todo: insert your jtag-reset code here ...>
}
<?if (N("cpu:watchdog:index") > 0) show(); else hide();?>
// ----------------
// --- watchdog ---
// ----------------

#define watchdogReset() asm volatile ("wdr")

void watchdogOff(void)
{
	watchdogReset();
	<?$cpu:watchdog:wdtcsr?> |= (1<<WDCE) | (1<<WDE);
	<?$cpu:watchdog:wdtcsr?> = 0x00;
}
<?if (B("00_main:enable usart")) include("usart\\usart.c");?>
<?if (B("00_main:enable timer")) include("timer\\timer.c");?>
<?if (B("00_main:enable delayloop")) include("delayloop.c");?>
<?if (B("00_main:enable eeprom")) include("eeprom\\eeprom.c");?>
<?if (B("00_main:enable spi")) include("spi.c");?>
<?if (B("00_main:enable twi")) include("twi.c");?>
<?if (B("00_main:enable 1wire")) include("1wire.c");?>
<?show();?>
// ------------
// --- main ---
// ------------

<?$initHeader?>

int main()
{
<?if (B("00_main:check reset type")) show(); else hide();?>	// check reset type
	if (<?$cpu:mcusr?> & (1<<WDRF)) onWatchdogReset(); // Watchdog Reset Flag
	if (<?$cpu:mcusr?> & (1<<PORF)) onPowerOnReset(); // Power-on Reset Flag
	if (<?$cpu:mcusr?> & (1<<EXTRF)) onExternalReset(); // External Reset Flag
	if (<?$cpu:mcusr?> & (1<<BORF)) onBrownOutReset(); // Brown-out Reset Flag
<?if (B("00_main:check reset type") && B("cpu:jtag")) show(); else hide();?>	if (<?$cpu:mcusr?> & (1<<JTRF)) onJTAGReset(); // JTAG Reset Flag
<?if (N("cpu:sleep:index") > 0) { show(); P("//todo: enable sleep..."); }?>
<?show();?><?$initCalls?>	// <todo: insert your main code here ...>
	return 0;
}
<?show();P("\r\n\r\n// generated by AvrWiz on "+System.DateTime.Now);?>