<?
int usartNum     = (int)N("02_usart:usart");
string usartName = "USART"+S("02_usart:usart");
int baud         = (int)N("02_usart:usart0:baud");
int realbaud     = (int)N("02_usart:usart0:realbaud");
string usartErr  = S("02_usart:usart0:err");
?>// -------------
// --- usart ---
// -------------

#include <avr/io.h>
//#include <avr/interrupt.h>

// the values are calculated with AvrWiz for <?$cpu:cpu?> @ <?$cpu:mhz?> mhz
// <?P(usartName);?> settings: <?P(baud);?> baud <?$02_usart:usart0:databits?>-<?$02_usart:usart0:parity?>-<?$02_usart:usart0:stopbits?>
<?if (baud != realbaud) P("// !!! warning !!! real baud = "+realbaud+", err = "+usartErr+"% !!!\r\n");
if (B("02_usart:usart0:rxbuffer") && N("02_usart:usart0:databits") < 9) show(); else hide();?>
#define <?P(usartName);?>_InSize <?$02_usart:usart0:rxbuflen?>
static unsigned char <?P(usartName);?>_InBuf[<?P(usartName);?>_InSize];
static volatile unsigned char <?P(usartName);?>_InPos = 0;
static volatile unsigned char <?P(usartName);?>_OutPos = 0;

// <?P(usartName);?> RX Complete
ISR(<?$02_usart:usart0:irq_rx?>_vect)
{
	<?P(usartName);?>_InBuf[<?P(usartName);?>_InPos++] = <?$02_usart:usart0:cpu_udr?>;
	if (<?P(usartName);?>_InPos >= <?P(usartName);?>_InSize) <?P(usartName);?>_InPos = 0;
}
<?if (B("02_usart:usart0:rxbuffer") && N("02_usart:usart0:databits") >= 9) show(); else hide();?>
#define <?P(usartName);?>_InSize <?$02_usart:usart0:rxbuflen?>
static unsigned int <?P(usartName);?>_InBuf[<?P(usartName);?>_InSize];
static volatile unsigned char <?P(usartName);?>_InPos = 0;
static volatile unsigned char <?P(usartName);?>_OutPos = 0;

// <?P(usartName);?> RX Complete
ISR(<?$02_usart:usart0:irq_rx?>_vect)
{
	unsigned char status = <?$02_usart:usart0:cpu_ucsra?>;
	unsigned char h = (<?$02_usart:usart0:cpu_ucsrb?>>>1) & 0x01;
	unsigned char l = <?$02_usart:usart0:cpu_udr?>;
	if (status & ((1<<<?$02_usart:usart0:cpu_fe?>) | (1<<<?$02_usart:usart0:cpu_dor?>) | (1<<<?$02_usart:usart0:cpu_pe?>))) <?P(usartName);?>_InBuf[<?P(usartName);?>_InPos++] = -1;
	else <?P(usartName);?>_InBuf[<?P(usartName);?>_InPos++] = (h<<8) | l;
	if (<?P(usartName);?>_InPos >= <?P(usartName);?>_InSize) <?P(usartName);?>_InPos = 0;
}
<?if (B("02_usart:usart0:rx") && B("02_usart:interrupts") && !B("02_usart:usart0:rxbuffer")) show(); else hide();?>
// <?P(usartName);?> RX Complete
ISR(<?$02_usart:usart0:irq_rx?>_vect)
{
}
<?if (B("02_usart:usart0:tx") && B("02_usart:interrupts")) show(); else hide();?>
// <?P(usartName);?> TX Complete
ISR(<?$02_usart:usart0:irq_tx?>_vect)
{
}
<?if (B("02_usart:usart0:tx") && B("02_usart:interrupts")) show(); else hide();?>
// <?P(usartName);?> Data Register Empty
ISR(<?$02_usart:usart0:irq_de?>_vect)
{
}
<?show();?>
void <?P(usartName);?>_init()
{
	// Set baud rate
	<?$02_usart:usart0:cpu_ubrrh?> = <?$02_usart:usart0:v_ubrrh?>;
	<?$02_usart:usart0:cpu_ubrrl?> = <?$02_usart:usart0:v_ubrrl?>;
	<?$02_usart:usart0:cpu_ucsra?> = <?$02_usart:usart0:v_ucsra?>;
	// Enable receiver and transmitter
	<?$02_usart:usart0:cpu_ucsrb?> = <?P(S("02_usart:usart0:v_ucsrb"+(B("02_usart:interrupts")?":interrupts":"")));?>;
	// Set frame format
	<?$02_usart:usart0:cpu_ucsrc?> = <?$02_usart:usart0:v_ucsrc?>;
}
<?if (B("02_usart:usart0:tx") && N("02_usart:usart0:databits") < 9) show(); else hide();?>
void <?P(usartName);?>_write(unsigned char data)
{
	// Wait for empty transmit buffer
	while ( !( <?$02_usart:usart0:cpu_ucsra?> & (1<<<?$02_usart:usart0:cpu_udre?>)) ) ;
	// Put data into buffer, sends the data
	<?$02_usart:usart0:cpu_udr?> = data;
}
<?if (B("02_usart:usart0:tx") && N("02_usart:usart0:databits") >= 9) show(); else hide();?>
void <?P(usartName);?>_write(unsigned int data)
{
	// Wait for empty transmit buffer
	while ( !( <?$02_usart:usart0:cpu_ucsra?> & (1<<<?$02_usart:usart0:cpu_udre?>)) ) ;
	// Copy ninth bit to <?$02_usart:usart0:cpu_txb8?>
	<?$02_usart:usart0:cpu_ucsrb?> &= ~(1<<<?$02_usart:usart0:cpu_txb8?>);
	if ( data & 0x0100 )
	<?$02_usart:usart0:cpu_ucsrb?> |= (1<<<?$02_usart:usart0:cpu_txb8?>);
	// Put data into buffer, sends the data
	<?$02_usart:usart0:cpu_udr?> = data;
}
<?if (B("02_usart:usart0:rx") && !B("02_usart:usart0:rxbuffer") && N("02_usart:usart0:databits") < 9) show(); else hide();?>
unsigned char <?P(usartName);?>_read()
{
	// Wait for data to be received
	while ( !(<?$02_usart:usart0:cpu_ucsra?> & (1<<<?$02_usart:usart0:cpu_rxc?>)) );
	// Get and return received data from buffer
	return <?$02_usart:usart0:cpu_udr?>;
}
<?if (B("02_usart:usart0:rx") && !B("02_usart:usart0:rxbuffer") && N("02_usart:usart0:databits") >= 9) show(); else hide();?>
unsigned int <?P(usartName);?>_read()
{
	unsigned char status, resh, resl;
	// Wait for data to be received
	while ( !(<?$02_usart:usart0:cpu_ucsra?> & (1<<<?$02_usart:usart0:cpu_rxc?>)) );
	// Get status and ninth bit, then data from buffer
	status = <?$02_usart:usart0:cpu_ucsra?>;
	resh = <?$02_usart:usart0:cpu_ucsrb?>;
	resl = <?$02_usart:usart0:cpu_udr?>;
	// If error, return -1
	if ( status & (1<<<?$02_usart:usart0:cpu_fe?>)|(1<<<?$02_usart:usart0:cpu_dor?>)|(1<<<?$02_usart:usart0:cpu_pe?>) )
		return -1;
	// Filter the ninth bit, then return
	resh = (resh >> 1) & 0x01;
	return ((resh << 8) | resl);
}
<?if (B("02_usart:usart0:rxbuffer") && N("02_usart:usart0:databits") < 9) show(); else hide();?>
unsigned char <?P(usartName);?>_read(void)
{
	unsigned char c;
	while (<?P(usartName);?>_InPos == <?P(usartName);?>_OutPos) sleep();
	c = <?P(usartName);?>_InBuf[<?P(usartName);?>_OutPos++];
	if (<?P(usartName);?>_OutPos >= <?P(usartName);?>_InSize) <?P(usartName);?>_OutPos = 0;
	return c;
}
<?if (B("02_usart:usart0:rxbuffer") && N("02_usart:usart0:databits") >= 9) show(); else hide();?>
unsigned int <?P(usartName);?>_read(void)
{
	unsigned int c;
	while (<?P(usartName);?>_InPos == <?P(usartName);?>_OutPos) sleep();
	c = <?P(usartName);?>_InBuf[<?P(usartName);?>_OutPos++];
	if (<?P(usartName);?>_OutPos >= <?P(usartName);?>_InSize) <?P(usartName);?>_OutPos = 0;
	return c;
}

<?show();?>
void init_usart()
{
	<?P(usartName);?>_init();
}

<?show();P("\r\n\r\n// generated by AvrWiz on "+System.DateTime.Now);?>
<?if (B("02_usart:help")) show(); else hide();?>
/*
USARTControl properties:
	num = <?$02_usart:usart0:num?>
	baud = <?$02_usart:usart0:baud?>
	databits = <?$02_usart:usart0:databits?>
	parity = <?$02_usart:usart0:parity?>
	stopbits = <?$02_usart:usart0:stopbits?>
	rx = <?$02_usart:usart0:rx?>
	tx = <?$02_usart:usart0:tx?>
	rxbuffer = <?$02_usart:usart0:rxbuffer?>
	rxbuflen = <?$02_usart:usart0:rxbuflen?>
	realbaud = <?$02_usart:usart0:realbaud?>
	err = <?$02_usart:usart0:err?>
	v_u2x = <?$02_usart:usart0:v_u2x?>
	v_ubrr = <?$02_usart:usart0:v_ubrr?>
	v_ubrrh = <?$02_usart:usart0:v_ubrrh?>
	v_ubrrl = <?$02_usart:usart0:v_ubrrl?>
	v_ucsra = <?$02_usart:usart0:v_ucsra?>
	v_ucsrb = <?$02_usart:usart0:v_ucsrb?>
	v_ucsrc = <?$02_usart:usart0:v_ucsrc?>
	irq_rx = <?$02_usart:usart0:irq_rx?>
	irq_tx = <?$02_usart:usart0:irq_tx?>
	irq_de = <?$02_usart:usart0:irq_de?>
	cpu_num = <?$02_usart:usart0:cpu_num?>
	cpu_ubrrh = <?$02_usart:usart0:cpu_ubrrh?>
	cpu_ubrrl = <?$02_usart:usart0:cpu_ubrrl?>
	cpu_udr = <?$02_usart:usart0:cpu_udr?>
	cpu_u2x = <?$02_usart:usart0:cpu_u2x?>
	cpu_udre = <?$02_usart:usart0:cpu_udre?>
	cpu_ucsra = <?$02_usart:usart0:cpu_ucsra?>
	cpu_ucsrb = <?$02_usart:usart0:cpu_ucsrb?>
	cpu_ucsrc = <?$02_usart:usart0:cpu_ucsrc?>
	cpu_ursel = <?$02_usart:usart0:cpu_ursel?>
	cpu_rxen = <?$02_usart:usart0:cpu_rxen?>
	cpu_txen = <?$02_usart:usart0:cpu_txen?>
	cpu_rxb8 = <?$02_usart:usart0:cpu_rxb8?>
	cpu_txb8 = <?$02_usart:usart0:cpu_txb8?>
	cpu_rxc = <?$02_usart:usart0:cpu_rxc?>
	cpu_ucsz0 = <?$02_usart:usart0:cpu_ucsz0?>
	cpu_ucsz1 = <?$02_usart:usart0:cpu_ucsz1?>
	cpu_ucsz2 = <?$02_usart:usart0:cpu_ucsz2?>
	cpu_upm0 = <?$02_usart:usart0:cpu_upm0?>
	cpu_upm1 = <?$02_usart:usart0:cpu_upm1?>
	cpu_usbs = <?$02_usart:usart0:cpu_usbs?>
	cpu_rxcie = <?$02_usart:usart0:cpu_rxcie?>
	cpu_txcie = <?$02_usart:usart0:cpu_txcie?>
	cpu_fe = <?$02_usart:usart0:cpu_fe?>
	cpu_dor = <?$02_usart:usart0:cpu_dor?>
	cpu_pe = <?$02_usart:usart0:cpu_pe?>
*/
<?show();?>